--"lut_and" component

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

LIBRARY altera;
USE altera.altera_primitives_components.all;

ENTITY lut_and IS
  PORT(
    s_in1      : IN STD_LOGIC;  --input signal 1
	 s_in2      : IN STD_LOGIC;  --input signal 2
	 s_out		: OUT STD_LOGIC  --output signal
    );
END lut_and;

ARCHITECTURE rtl OF lut_and IS

SIGNAL s_int1	: STD_LOGIC; --int. signal
SIGNAL s_int11	: STD_LOGIC; --int. signal
SIGNAL s_int12	: STD_LOGIC; --int. signal

COMPONENT lut_input
    PORT(

        a_in  :  IN    STD_LOGIC; 

        a_out :  OUT   STD_LOGIC
		  );
END COMPONENT;

COMPONENT lut_output
    PORT(

        a_in  :  IN   STD_LOGIC;

        a_out :  OUT   STD_LOGIC
		  );
END COMPONENT;

BEGIN

	s_int1 <= s_int11 AND s_int12;

lut_input_inst1 : lut_input 
	PORT MAP (
	a_in 		=> s_in1,
	a_out 	=> s_int11
);

lut_input_inst2 : lut_input 
	PORT MAP (
	a_in 		=> s_in2,
	a_out 	=> s_int12
);

lut_output_inst : lut_output
	PORT MAP (
	a_in		=> s_int1,
	a_out		=> s_out
);

END rtl;