--"lut_not" component

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

LIBRARY altera;
USE altera.altera_primitives_components.all;

ENTITY lut_not IS
  PORT(
    s_in      : IN STD_LOGIC;  --input signal
	 s_out		: OUT STD_LOGIC  --output signal
    );
END lut_not;

ARCHITECTURE rtl OF lut_not IS

SIGNAL s_int1	: STD_LOGIC; --int. signal
SIGNAL s_int2	: STD_LOGIC; --int. signal

COMPONENT lut_input
    PORT(

        a_in  :  IN    STD_LOGIC; 

        a_out :  OUT   STD_LOGIC
		  );
END COMPONENT;

COMPONENT lut_output
    PORT(

        a_in  :  IN   STD_LOGIC;

        a_out :  OUT   STD_LOGIC
		  );
END COMPONENT;

BEGIN
	s_int2 <= NOT s_int1;

lut_input_inst : lut_input 
	PORT MAP (
	a_in 		=> s_in,
	a_out 	=> s_int1
);

lut_output_inst : lut_output
	PORT MAP (
	a_in		=> s_int2,
	a_out		=> s_out
);

END rtl;