--This component ("tero_chain_cycV") is composed of 1 "lut_and", 6 "lcell"s avec 1 "lut_not" components.
--We will use 2 "tero_chain_cycV" to make the "tero_cycV" in an other file (tero_cycV.vhd).

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

LIBRARY altera;
USE altera.altera_primitives_components.all;
LIBRARY altera_mf;
USE altera_mf.altera_mf_components.all;  

ENTITY tero_chain_cycV IS
  PORT(
    s_in1      : IN STD_LOGIC;  --global input signal 1
	 s_in2      : IN STD_LOGIC;  --global input signal 2
	 s_out		: OUT STD_LOGIC  --global output signal
    );
END tero_chain_cycV;

ARCHITECTURE rtl OF tero_chain_cycV IS

SIGNAL s_int1	: STD_LOGIC; --intermediate signals
SIGNAL s_int2	: STD_LOGIC;
SIGNAL s_int3	: STD_LOGIC;
SIGNAL s_int4	: STD_LOGIC;
SIGNAL s_int5	: STD_LOGIC;
SIGNAL s_int6	: STD_LOGIC;
SIGNAL s_int7	: STD_LOGIC;
SIGNAL s_int8	: STD_LOGIC;
SIGNAL s_int9	: STD_LOGIC;

COMPONENT lcell
   PORT (
    a_in : IN STD_LOGIC;
	 a_out : OUT STD_LOGIC
	);
END COMPONENT;

COMPONENT lut_and
	PORT (
	 s_in1      : IN STD_LOGIC;  --input signal 1
	 s_in2      : IN STD_LOGIC;  --input signal 2
	 s_out		: OUT STD_LOGIC  --output signal
	);
END COMPONENT;

COMPONENT lut_not
	PORT (
	 s_in      : IN STD_LOGIC;  --input signal
	 s_out		: OUT STD_LOGIC  --output signal
	);
END COMPONENT;

BEGIN

--lut_and instantiation
i_lut_and : lut_and
	PORT MAP (
	s_in1 => s_in1,
	s_in2 => s_in2,
	s_out => s_int1
);
--6 "lcell" instantiations below
lcell1 : lcell
	PORT MAP (
	a_in => s_int1,
	a_out => s_int2
);
lcell2 : lcell
	PORT MAP (	
	a_in => s_int2,
	a_out => s_int3
);
lcell3 : lcell
	PORT MAP (
	a_in => s_int3,
	a_out => s_int4
);
lcell4 : lcell
	PORT MAP (	
	a_in => s_int4,
	a_out => s_int5
);
lcell5 : lcell
	PORT MAP (
	a_in => s_int5,
	a_out => s_int6
);
lcell6 : lcell
	PORT MAP (	
	a_in => s_int6,
	a_out => s_int7
);
lcell7 : lcell
	PORT MAP (	
	a_in => s_int7,
	a_out => s_int8
);
lcell8 : lcell
	PORT MAP (	
	a_in => s_int8,
	a_out => s_int9
);

--lut_not instantiation
i_lut_not : lut_not
	PORT MAP (
	s_in => s_int9,
	s_out => s_out
);

END rtl;