--The "tero_cycV" is composed of two "tero_chain_cycV" components.
--It uses LUT and LCELL "primitives".

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

LIBRARY altera;
USE altera.altera_primitives_components.all;
LIBRARY altera_mf;
USE altera_mf.altera_mf_components.all; 


ENTITY tero_cycV IS
  PORT(
    enable      : IN STD_LOGIC;  --global input signal 1
	 output		: OUT STD_LOGIC  --global output signal
    );
END tero_cycV;

ARCHITECTURE rtl OF tero_cycV IS

SIGNAL s_int1	: STD_LOGIC; --intermediate signals
SIGNAL s_int2	: STD_LOGIC; 

COMPONENT tero_chain_cycV
  PORT(
    s_in1      : IN STD_LOGIC;  --global input signal 1
	 s_in2      : IN STD_LOGIC;  --global input signal 2
	 s_out		: OUT STD_LOGIC  --global output signal
    );
END COMPONENT;

BEGIN

--instantiations of the 2 "tero_chain_cycV" components

i_tero_chain_cycV_1 : tero_chain_cycV
	PORT MAP (
	s_in1 => enable,
	s_in2 => s_int2,
	s_out => s_int1
);

i_tero_chain_cycV_2 : tero_chain_cycV
	PORT MAP (
	s_in1 => s_int1,
	s_in2 => enable,
	s_out => s_int2
);

output <= s_int1;

END rtl;